// This file is part of PUMA.
// Copyright (C) 1999-2003  The PUMA developer team.
//                                                                
// This program is free software;  you can redistribute it and/or 
// modify it under the terms of the GNU General Public License as 
// published by the Free Software Foundation; either version 2 of 
// the License, or (at your option) any later version.            
//                                                                
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
// GNU General Public License for more details.                   
//                                                                
// You should have received a copy of the GNU General Public      
// License along with this program; if not, write to the Free     
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
// MA  02111-1307  USA                                            

#ifndef __StrHashTable_h__
#define __StrHashTable_h__

#include "Puma/StrHashKey.h"
#include <assert.h>

namespace Puma {


class StrHashTable {
  StrHashKey *_emptyKey;

public:
  StrHashTable () {
    _emptyKey = insert ("");
    assert (_emptyKey);
  }

  StrHashKey *empty () const { assert (_emptyKey); return _emptyKey; }
  StrHashKey *insert (const char *);
  void remove (StrHashKey *);
  void clear ();

  enum { STRHASHTABLE_SIZE=0xffff };
  
private:
  Chain m_Table[STRHASHTABLE_SIZE];

  StrHashKey *find (unsigned long, const char *, unsigned long);
  unsigned long hash (const char *, unsigned long &);
};


} // namespace Puma

#endif /* __StrHashTable_h__ */
