#ifndef __ac_FIRST__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1__
#define __ac_FIRST__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1__
#define __ac_FIRST_FILE__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_inc_Puma_Array_h__

#ifndef __ac_h_
#define __ac_h_
#ifdef __cplusplus
namespace AC {
  typedef const char* Type;
  enum JPType { CALL = 0x0004, EXECUTION = 0x0008, CONSTRUCTION = 0x0010, DESTRUCTION = 0x0020 };
  struct Action {
    void **_args; void *_result; void *_target; void *_that; void *_fptr;
    void (*_wrapper)(Action &);
    inline void trigger () { _wrapper (*this); }
  };
  struct AnyResultBuffer {};
  template <typename T> struct ResultBuffer : public AnyResultBuffer {
    struct { char _array[sizeof (T)]; } _data;
    ~ResultBuffer () { ((T&)_data).T::~T(); }
    operator T& () const { return (T&)_data; }
  };
  template <typename T, typename N> struct TL {
    typedef T type; typedef N next; enum { ARGS = next::ARGS + 1 };
  };
  struct TLE { enum { ARGS = 0 }; };
  template <typename T> struct Referred { typedef T type; };
  template <typename T> struct Referred<T &> { typedef T type; };
  template <typename TL, int I> struct Arg {
    typedef typename Arg<typename TL::next, I - 1>::Type Type;
    typedef typename Referred<Type>::type ReferredType;
  };
  template <typename TL> struct Arg<TL, 0> {
    typedef typename TL::type Type;
    typedef typename Referred<Type>::type ReferredType;
  };
  template <typename T> int ttest(...);
  template <typename T> char ttest(typename T::__AttrTypes const volatile *);
  template<typename T> struct HasTypeInfo {
    enum { RET=((sizeof(ttest<T>(0))==1)?1:0) };
  };
  template<typename T, int HAVE = HasTypeInfo<T>::RET> struct TypeInfo {
    enum { AVAILABLE = 0 };
  };
  template<typename T> struct TypeInfo<T, 1> {
    enum { AVAILABLE = 1 };
    enum { ELEMENTS = T::__AttrTypes::ARGS };
    template<int I>
    struct Member : public AC::Arg<typename T::__AttrTypes,I> {};
    template<int I>
    static typename Member<I>::ReferredType* member (T* obj) {
      return (typename Member<I>::ReferredType*)obj->__attr (I);
    }
    static const char *member_name (T &obj, int i) {
      return obj.__attr_name (i);
    }
	 };
  template <class Aspect, int Index>
  struct CFlow {
    static int &instance () {
      static int counter = 0;
      return counter;
    }
    CFlow () { instance ()++; }
    ~CFlow () { instance ()--; }
    static bool active () { return instance () > 0; }
  };
}
inline void * operator new (__SIZE_TYPE__, AC::AnyResultBuffer *p) { return p; }
inline void operator delete (void *, AC::AnyResultBuffer *) { } // for VC++
#endif // __cplusplus
#endif // __ac_h_
#endif // __ac_FIRST__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1__

#line 1 "/home/akut/Akut/package/aspectc++/Puma/gen-release/step1/inc/Puma/Array.h"
// This file is part of PUMA.
// Copyright (C) 1999-2003  The PUMA developer team.
//                                                                
// This program is free software;  you can redistribute it and/or 
// modify it under the terms of the GNU General Public License as 
// published by the Free Software Foundation; either version 2 of 
// the License, or (at your option) any later version.            
//                                                                
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
// GNU General Public License for more details.                   
//                                                                
// You should have received a copy of the GNU General Public      
// License along with this program; if not, write to the Free     
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
// MA  02111-1307  USA                                            

#ifndef __array_h__
#define __array_h__

/** \file
 *  Variable length array implementation. */

#include <assert.h>

namespace Puma {


/** \class Array Array.h Puma/Array.h
 *  Variable length array implementation. */
template <class Item>
class Array {
protected:
  /** Default array size. */
  static const long default_init_size = 5;
  /** Default array size increment. */
  static const long default_increment = 5;

public:
  /** Constructor.
   *  \param is The default size of the array. 
   *  \param incr The default increment value. */
  Array (long is = default_init_size, long incr = default_increment);
  /** Copy-constructor.
   *  \param array The array to copy. */
  Array (const Array<Item>& array);
  /** Assignment operator.
   *  \param copy The array to copy. */
  Array<Item>& operator =(const Array<Item>& copy);
  /** Destructor. Destroys the array. */
  ~Array ();
  /** Append an item to the array. 
   *  \param item The item to append. */
  void append (const Item& item);
  /** Insert an item at the given array index. 
   *  \param index The array index. 
   *  \param item The item to insert. */
  void insert (long index, const Item& item);
  /** Prepend an item. 
   *  \param item The item to prepend. */
  void prepend (const Item& item);
  /** Remove the array item at the given array index.
   *  \param index The array index. */
  void remove (long index);
  /** Reset the array. Destroys the current array. */
  void reset ();
  /** Get a reference to the array item at the given 
   *  array index. If the index exceeds the array
   *  bounds, then the array is reallocated accordingly.
   *  \param index The array index. */
  Item& get (long index);
  /** Get a reference to the array item at the given 
   *  array index. If the index exceeds the array
   *  bounds, then the array is reallocated accordingly.
   *  \param index The array index. */
  Item& operator[] (long index);
  /** Get the array item at the given array index.
   *  Does not return a reference, thus the item may
   *  be implicitely copied. 
   *  \warning Does not validate the index!
   *  \param index The array index. */
  Item fetch (long index) const;
  /** Get a reference to the array item at the given 
   *  array index.
   *  \warning Does not validate the index!
   *  \param index The array index. */
  Item& lookup (long index) const;
  /** Get the number of items in the array. */
  long length () const;

private:
  Item* data;
  long size;
  long count;
  long increment;
      
  void grow (long wanted);
};

template <class Item>
inline Array<Item>::Array (long is, long incr) {
  count     = 0; 
  size      = is;
  increment = incr;
  data      = 0;
}

template <class Item>
Array<Item>::Array (const Array<Item>& array) {
  count     = 0;
  size      = array.size;
  increment = array.increment;
  
  if (size && array.data) {
    data = new Item[size];
    for (; count < array.count; count++) {
      data[count] = array.data[count];
    }
  } else
    data = 0;
}

template <class Item>
Array<Item>& Array<Item>::operator =(const Array<Item>& array) {
  if (data)
    delete[] data;
 
  count     = 0;
  size      = array.size;
  increment = array.increment;

  if (size && array.data) {
    data = new Item[size];
    for (; count < array.count; count++) {
      data[count] = array.data[count];
    }
  } else
    data = 0;
  
  return *this;
}

template <class Item>
Array<Item>::~Array () {
  if (data)
    delete[] data;
}

template <class Item>
inline void Array<Item>::grow (long wanted) {
  do {
    size += increment;
    increment *= 2;
  } while (wanted >= size);

  if (data) {
    Item* new_data = new Item[size];
    for (long i = 0; i < count; i++) {
      new_data[i] = data[i];
    }
    delete[] data;
    data = new_data;
  } else
    data = new Item[size];
}
   
template <class Item>
inline void Array<Item>::append (const Item& item) {
  if (count >= size || ! data) {
    grow (count);
  }
  data[count++] = item;
}

template <class Item>
void Array<Item>::prepend (const Item& item) {
  insert (0, item);
}

template <class Item>
void Array<Item>::insert (long index, const Item& item) {
  if (count >= size || ! data) {
    grow (count);
  }
  for (long i = count; i > index; i--)
    data[i] = data[i - 1];
  data[index] = item;
  count++;
}

template <class Item>
inline Item& Array<Item>::get (long index) {
  if (index >= size || ! data) {
    grow (index);
  }
  if (index >= count)
    count = index + 1;
  return data[index];
}

template <class Item>
inline Item& Array<Item>::operator[] (long index) {
  return get (index);
}

template <class Item>
inline Item Array<Item>::fetch (long index) const {
  assert(index < count && data);
  return data[index];
}

template <class Item>
inline long Array<Item>::length () const {
  return count;
}

template <class Item>
inline void Array<Item>::remove (long index) {
  if (index < count && count > 0) {
    for (long i = index; i < count - 1; i++)
      data[i] = data[i + 1];
    count--;
  }
}

#ifndef __puma
template <>
inline void Array<int>::reset () {
  count = 0; 
}
#endif

template <class Item>
void Array<Item>::reset () {
  if (data)
    delete[] data;
    
  count     = 0; 
  size      = default_init_size;
  increment = default_increment;
  data      = new Item[size];
}

template <class Item>
inline Item& Array<Item>::lookup (long index) const {
  assert(index >= 0 && index < count);
  return data[index];
}


} // namespace Puma

// Array specialization for pointer types sharing method definitions

#ifndef __puma

#include "Puma/VoidPtrArray.h"

namespace Puma {


template <class Item>
class Array<Item*> : private VoidPtrArray {
  typedef VoidPtrArray Base;

public:
  Array (long is = default_init_size, long incr = default_increment) :
    Base (is, incr) {}
  Array (const Array<Item*> &array) : 
    Base (array) {}
  Array<Item*> &operator= (const Array<Item*> &array) 
   { return (Array<Item*>&)Base::operator= (array); }

  ~Array () {}

  void append (const Item *item)           { Base::append ((void*)item); }
  void insert (long idx, const Item *item) { Base::insert (idx, (void*)item); }
  void prepend (const Item *item)          { Base::prepend ((void*)item); }
  void remove (long idx)                   { Base::remove (idx); }
  void reset ()                            { Base::reset (); }

  Item *&get (long idx)                    { return (Item*&)Base::get (idx); }
  Item *&operator[] (long idx)             { return (Item*&)Base::operator[] (idx); }
  Item *fetch (long idx) const             { return (Item*)Base::fetch (idx); }
  Item *&lookup (long idx) const           { return (Item*&)Base::lookup (idx); }
  long length () const                     { return Base::length (); }
};


} // namespace Puma

#endif /* __puma */

#endif /* __array_h__ */

#line 372 "/home/akut/Akut/package/aspectc++/Puma/gen-release/step2/inc/Puma/Array.h"

#ifdef __ac_FIRST_FILE__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_inc_Puma_Array_h__
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCExprResolveCC_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCExprResolveCC_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCExprResolveCC_ah__
#include "CCExprResolveCC.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCExprResolveH_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCExprResolveH_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCExprResolveH_ah__
#include "CCExprResolveH.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CExprResolveCC_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CExprResolveCC_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CExprResolveCC_ah__
#include "CExprResolveCC.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CExprResolveH_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CExprResolveH_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CExprResolveH_ah__
#include "CExprResolveH.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxState_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxState_ah__
#include "SyntaxState.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxBuilder_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxBuilder_ah__
#include "SyntaxBuilder.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtAC_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtAC_ah__
#include "ExtAC.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#include "ExtACKeywords.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxBuilder_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxBuilder_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxBuilder_ah__
#include "SyntaxBuilder.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_LookAhead_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxBuilder_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxBuilder_ah__
#include "SyntaxBuilder.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_LookAhead_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_LookAhead_ah__
#include "LookAhead.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CBuilderExtension_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CBuilderExtension_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CBuilderExtension_ah__
#include "CBuilderExtension.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CLookAhead_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CLookAhead_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CLookAhead_ah__
#include "CLookAhead.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CSemBinding_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxBuilder_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxBuilder_ah__
#include "SyntaxBuilder.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CSemBinding_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CSemBinding_ah__
#include "CSemBinding.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtAC_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtAC_ah__
#include "ExtAC.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__
#include "ExtACBuilderH.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#include "ExtACKeywords.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCBuilderExtension_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCBuilderExtension_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCBuilderExtension_ah__
#include "CCBuilderExtension.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__
#include "ExtACBuilderH.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCLookAhead_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCLookAhead_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCLookAhead_ah__
#include "CCLookAhead.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCSemBinding_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxBuilder_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxBuilder_ah__
#include "SyntaxBuilder.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_LookAhead_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_LookAhead_ah__
#include "LookAhead.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CLookAhead_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CLookAhead_ah__
#include "CLookAhead.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CSemBinding_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CSemBinding_ah__
#include "CSemBinding.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCLookAhead_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCLookAhead_ah__
#include "CCLookAhead.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCSemBinding_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_CCSemBinding_ah__
#include "CCSemBinding.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinAsm_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinAsm_ah__
#include "WinAsm.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinDeclSpecs_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinDeclSpecs_ah__
#include "WinDeclSpecs.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinMemberExplSpec_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinMemberExplSpec_ah__
#include "WinMemberExplSpec.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinTypeKeywords_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinTypeKeywords_ah__
#include "WinTypeKeywords.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinFriend_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinFriend_ah__
#include "WinFriend.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtAC_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtAC_ah__
#include "ExtAC.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__
#include "ExtACBuilderH.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACSyntaxH_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACSyntaxH_ah__
#include "ExtACSyntaxH.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#include "ExtACKeywords.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinIfExists_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinIfExists_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinIfExists_ah__
#include "WinIfExists.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinImportHandler_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinImportHandler_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinImportHandler_ah__
#include "WinImportHandler.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinMacros_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinMacros_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinMacros_ah__
#include "WinMacros.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinAsm_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinAsm_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinAsm_ah__
#include "WinAsm.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinDeclSpecs_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinDeclSpecs_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinDeclSpecs_ah__
#include "WinDeclSpecs.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinMemberExplSpec_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinMemberExplSpec_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinMemberExplSpec_ah__
#include "WinMemberExplSpec.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinTypeKeywords_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinTypeKeywords_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinTypeKeywords_ah__
#include "WinTypeKeywords.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinFriend_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinFriend_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_WinFriend_ah__
#include "WinFriend.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtAC_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxBuilder_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_SyntaxBuilder_ah__
#include "SyntaxBuilder.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtAC_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtAC_ah__
#include "ExtAC.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#include "ExtACKeywords.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACBuilderH_ah__
#include "ExtACBuilderH.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACBuilderCC_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACBuilderCC_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACBuilderCC_ah__
#include "ExtACBuilderCC.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACSyntaxH_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACSyntaxH_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACSyntaxH_ah__
#include "ExtACSyntaxH.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACSyntaxCC_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACSyntaxCC_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACSyntaxCC_ah__
#include "ExtACSyntaxCC.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACKeywords_ah__
#include "ExtACKeywords.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnu_ah__
#include "ExtGnu.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCSemDeclSpecs_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtACTree_ah__
#include "ExtACTree.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCSemDeclSpecs_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCSemDeclSpecs_ah__
#include "ExtGnuCSemDeclSpecs.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_ExtGnuCTree_ah__
#include "ExtGnuCTree.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#endif
#ifdef __ac_need__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnce_ah__
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnceUnitState_ah__
#include "PragmaOnceUnitState.ah"
#endif
#ifndef __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnce_ah__
#define __ac_have__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_aspects_PragmaOnce_ah__
#include "PragmaOnce.ah"
#endif
#endif
#undef __ac_FIRST__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1__
#undef __ac_FIRST_FILE__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_inc_Puma_Array_h__
#endif // __ac_FIRST_FILE__home_akut_Akut_package_aspectc4343_Puma_gen45release_step1_inc_Puma_Array_h__
