// This file is part of PUMA.
// Copyright (C) 1999-2003  The PUMA developer team.
//                                                                
// This program is free software;  you can redistribute it and/or 
// modify it under the terms of the GNU General Public License as 
// published by the Free Software Foundation; either version 2 of 
// the License, or (at your option) any later version.            
//                                                                
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
// GNU General Public License for more details.                   
//                                                                
// You should have received a copy of the GNU General Public      
// License along with this program; if not, write to the Free     
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
// MA  02111-1307  USA                                            

#ifndef __fd_source_h__
#define __fd_source_h__

#include "Puma/Source.h"
#include "Puma/SysCall.h"

namespace Puma {


class FdSource : public Source {
  int _fd;

public:
  FdSource () : _fd (-1) {}
  FdSource (int fdesc) : _fd (fdesc) {}
  virtual ~FdSource () {}

  virtual int read (char *dest, int n)
   { return SysCall::read (_fd, dest, n); }

  void fd (int fdesc) { _fd = fdesc; }
  int fd () { return _fd; }

  int size () {
    FileInfo fileinfo;
    return (SysCall::fstat (_fd, fileinfo)) ? fileinfo.size () : -1;
  }
};


} // namespace Puma

#endif /* __fd_source_h__ */
