// This file is part of PUMA.
// Copyright (C) 1999-2003  The PUMA developer team.
//                                                                
// This program is free software;  you can redistribute it and/or 
// modify it under the terms of the GNU General Public License as 
// published by the Free Software Foundation; either version 2 of 
// the License, or (at your option) any later version.            
//                                                                
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
// GNU General Public License for more details.                   
//                                                                
// You should have received a copy of the GNU General Public      
// License along with this program; if not, write to the Free     
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
// MA  02111-1307  USA                                            

#ifndef __filename_info_h__
#define __filename_info_h__

#include "Puma/RefCnt.h"
#include "Puma/DString.h"

namespace Puma {


class FilenameInfo : public RefCnt {
  DString _name;
  const char *_path;
  const char *_root;

public:
  FilenameInfo () : _path ((const char*)0), _root ((const char*)0) {}
  ~FilenameInfo ();
  void name (const char *n);
//  void name (const DString &dsn) { _name = dsn; }
  const char *name () const { return _name.c_str (); }
  const char *path ();
  const char *root ();
  bool is_absolute () const;
  bool operator == (const FilenameInfo &rc) const {
    return _name == rc._name;
  }
};


} // namespace Puma

#endif /* __filename_info_h__ */
